Option Explicit

Dim gstrSourcePath, gstrDestinationPath
Dim giFilter, gbTransparentCategories, gstrProjectPath
Dim gobjArgs
Set gobjArgs = WScript.Arguments
If gobjArgs.Count >= 2 Then 
	gstrSourcePath = gobjArgs(0)
	gstrDestinationPath = gobjArgs(1)
End If

Dim strCsvText
strCsvText = TransformXsl(gstrSourcePath)
SaveCsv gstrDestinationPath, strCsvText

Function GetStylesheetPath()
	Dim fso, strAppPath
	Set fso = CreateObject("Scripting.FileSystemObject")
	strAppPath = fso.GetParentFolderName(WScript.ScriptFullName)
	GetStylesheetPath = fso.BuildPath(strAppPath, "ProjectTasksCsv.xsl")
End Function

Function TransformXsl(strSourcePath)
	Dim oStyleSheet, oTemplate, oProcessor, oXmlDoc
	Dim isLoaded
	Set oStyleSheet = CreateObject("Msxml2.FreeThreadedDOMDocument.4.0")
	isLoaded = oStyleSheet.load(GetStylesheetPath())
	Set oTemplate = CreateObject("Msxml2.XSLTemplate.4.0")
	Set oTemplate.stylesheet = oStyleSheet
	Set oProcessor = oTemplate.createProcessor()
	Set oXmlDoc = CreateObject("Msxml2.FreeThreadedDOMDocument.4.0")
	isLoaded = oXmlDoc.load(strSourcePath)
	oProcessor.input = oXmlDoc

	Dim item
	For Each item In gobjArgs.Named
		oProcessor.addParameter item, gobjArgs.Named.Item(item)
	Next
	oProcessor.transform()
	TransformXsl = oProcessor.output
End Function

Function SaveCsv(strDestinationPath, strCsvText)
	Dim fso, oStream
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set oStream = fso.CreateTextFile(strDestinationPath, True)
	oStream.Write strCsvText
	oStream.Close()
End Function
